# Contributor's Agreement

This code is licensed under the MIT [LICENSE](../LICENSE).

# Contributing

When contributing to a HPCIC DevTools project, it is
important to properly communicate the gist of the contribution.
If it is a simple code or editorial fix, simply explaining this
within the GitHub Pull Request (PR) will suffice. But if this is a larger
fix or Enhancement, it should be first discussed with the project
leader or developers.

Please note we have a code of conduct, described below. Please follow it in
all your interactions with the project members and users.

## Pull Request Process

1. Bug fix PRs should be sent to the main branch.
2. Follow the existing code style precedent. Use pre-commit to lint.
3. Test your PR locally, and provide the steps necessary to test for the
   reviewers.
4. The project's default copyright and header have been included in any new
   source files.
5. All (major) changes must be documented in the `docs` directory and `CHANGELOG.md`.
6. If necessary, update the README.md.
7. The pull request will be reviewed by others, and the final merge must be
   done by the project lead, @vsoch (or approved by her).
